#INCLUDE "rwmake.ch"
#INCLUDE "topconn.ch"

/*/
+--+
| Funcao    | RMEXPS4                                                       |
+--+--+--+--+
| Autor     | Emerson B. do Nascimento                  | Data | 24/08/2010 |
+--+--+--+--+
| Descricao |Programa para gerar arquivos c/ dados de NF para transportadora|
|           |                                                               |
+--+--+
| Uso       | Especifico RM                                                 |
+--+
+--+
| Atualizaes Sofridas Desde a Construo Inicial                          |
+--+
| Programador | Data       | Motivo da Alteracao                            |
+--+--+--+
|			  |			   |												|
+--+--+--+ /*/

***********************
User Function RMExpS4()
***********************

//----------------------------------//
//Chama as perguntas do programa    //
//----------------------------------//
Pergunte("RMEXPS4",.T.)

//------------------------------------------------//
// Montagem da tela de interface com o usuario.   //
//------------------------------------------------//
@ 200,1 TO 380,380 DIALOG oDlg TITLE OemToAnsi("Arquivo Reg Transporte NFE")
@ 02,10 TO 080,180
@ 10,016 Say "Exportacao de arquivos para transportadora NFE, geracao em C:\ "

@ 60,118 BMPBUTTON TYPE 01 ACTION MsgRun("AGUARDE, Gerando Arquivos...",, { || OkInicia() } )
@ 60,148 BMPBUTTON TYPE 02 ACTION Close(oDlg)

Activate Dialog oDlg Centered

Return .t.




//verificar qual tipo de funo gera chamanda
*************************
Static Function OkInicia()
*************************

if (MV_PAR01) == 1 .OR. (MV_PAR01) == 3
	//caso a opcao seja somente p/ gera arquivo em disc
	OkGera()
endif
if (MV_PAR01) == 2 .OR. (MV_PAR01) == 3
	//caso a opcao seja somente p/ imprimir o arquivo
	OkImprimir()
endif

Close(oDlg)

MsgInfo("Arquivo(s) gerado(s) com sucesso!")



Return .T.
//-----------------------------------------------------//
// Cria arquivo referente aos dados dos clientes       //
//-----------------------------------------------------//
*************************
Static Function OkGera()
*************************
Local c_arquivo := AllTrim(MV_PAR04)+"ARQUIVOTRANS.TXT"
Local n_outfile := Fcreate(c_arquivo,0)
Local nRegs     := 0
Local cQuery
Local cHeader,cDescrArq,cHeader2,cDetal1,cDetal2,cTrailer
//Local nTotVol = 0

//-----------------------------------//
//Monta Registro do Header           //
//-----------------------------------//
cHeader := "PENIEL DISTRIBUIDORA DE MEDICAMENTOS LTDA"
Fwrite(n_outfile, cHeader + chr(13)+chr(10), len(cHeader) + 2)
//-------------------------------------//
//Linhas do ttulo  do arquivo         //
//-------------------------------------//
cDescrArq := replicate("-",204)+chr(10)+chr(13)
cDescrArq += Space(87)+"LISTAGEM DE NOTAS FISCAIS PARA AVERBACAO"+Space(77)+chr(10)+chr(13)
cDescrArq += replicate("-",204)
Fwrite(n_outfile, cDescrArq + chr(13)+chr(10), Len(cDescrArq) + 2)
//-------------------------------------//
//Descricao do Header do arquivo       //
//-------------------------------------//
cHeader2 := "PRIORIDADE"+Space(2)+"ROTA"+Space(2)+"NUMERO NF"+Space(2)+"EMISSAO"+Space(5)+"QTDE. VOLUMES"+Space(2)
cHeader2 += "DESTINATARIO"+Space(30)+"CIDADE"+Space(36)+"FONE"+Space(16)+"VALOR TOTAL"+Space(2)
cHeader2 += "CHAVE DE ACESSO NFE"+Space(22)
Fwrite(n_outfile, cHeader2 + chr(13)+chr(10), Len(cHeader2) + 2)

cHeader2 := replicate("=",10)+Space(2)+replicate("=",4)+Space(2)+replicate("=",9)+Space(2)
cHeader2 += replicate("=",10)+Space(2)+replicate("=",13)+Space(2)+replicate("=",40)+Space(2)
cHeader2 += replicate("=",40)+Space(2)+replicate("=",18)+Space(2)+replicate("=",11)+Space(2)
cHeader2 += replicate("=",44)
Fwrite(n_outfile, cHeader2 + chr(13)+chr(10), Len(cHeader2) + 2)


cQuery := "SELECT A1_RMPRIOE AS PRIORIDADE,A1_RMRTTRA AS ROTA, "
cQuery += "F2_DOC AS NUMERO_NF, F2_SERIE AS SERIE_NF,F2_EMISSAO AS EMISSAO, "
cQuery += "F2_VOLUME1 AS QTDE_VOLUMES, A1_NOME AS DESTINATARIO, "
cQuery += "A1_MUN AS CIDADE, A1_DDD+A1_TEL AS FONE, "
cQuery += "F2_VALBRUT AS VALOR_TOTAL, F2_CHVNFE AS CHAVE_DE_ACESSO_NFE "
cQuery += "FROM SF2010 F INNER JOIN SA1010 A ON F2_CLIENTE = A1_COD AND F2_LOJA = A1_LOJA  "
cQuery += "INNER JOIN SD2010 D ON F2_DOC = D2_DOC AND F2_SERIE = D2_SERIE "
cQuery += "INNER JOIN SC5010 C ON D2_PEDIDO = C5_NUM "
cQuery += "WHERE  F.F2_SERIE <> 'ZZZ' AND A1_ATIVO = 'S' "
cQuery += "AND D.D2_FILIAL = '"+xFilial("SD2")+"' AND F.F2_FILIAL = '"+xFilial("SF2")+"' "
cQuery += "AND A.A1_FILIAL = '"+xFilial("SA1")+"' AND C.C5_FILIAL = '"+xFilial("SC5")+"' AND "
cQuery += "C.D_E_L_E_T_ <> '*' AND F.D_E_L_E_T_ <> '*' AND D.D_E_L_E_T_ <> '*' AND  "
cQuery += "A.D_E_L_E_T_ <> '*' AND C5_ROTARM = '100' AND "
cQuery += "F.F2_EMISSAO BETWEEN '"+DtoS(MV_PAR02)+"' AND '"+DtoS(MV_PAR03)+"' "
cQuery += "GROUP BY A1_RMPRIOE, A1_RMRTTRA, F2_DOC,F2_SERIE,  "
cQuery += "F2_EMISSAO,F2_VOLUME1, A1_NOME,A1_MUN, A1_DDD,A1_TEL, "
cQuery += "F2_VALBRUT, F2_CHVNFE ORDER BY A1_RMPRIOE, NUMERO_NF "

//--------------------------------//
//Executa query e manda p/ TRB    //
//--------------------------------//
TCQUERY cQuery NEW ALIAS "TRB"

nTotVol = 0
dbSelectArea("TRB")
dbGoTop()
While !Eof()
	//----------------------------------//
	// Grava o Arquivo com a xml da nfe //
	//----------------------------------//
	NfeXML(TRB->NUMERO_NF, TRB->SERIE_NF)
	
	//-------------------------------------//
	//Monta registro do detalhe 2          //
	//-------------------------------------//
	cDetal2 := TRB->PRIORIDADE+Space(10) + TRB->ROTA+Space(3)+TRB->NUMERO_NF+Space(2)
	cDetal2 += DtoC(StoD(TRB->EMISSAO)) +Space(4) + StrZero(TRB->QTDE_VOLUMES,3)+Space(12)+ TRB->DESTINATARIO+Space(2)+TRB->CIDADE+Space(2)
	cDetal2 += TRB->FONE + Space(3) + StrZero(TRB->VALOR_TOTAL,10,2) + Space(2) + TRB->CHAVE_DE_ACESSO_NFE
	Fwrite(n_outfile, cDetal2 + chr(13)+chr(10), Len(cDetal2) + 2)
	
	//	nRegs ++
	//calcular somente notas que o Volume for maior que 0
	if(TRB->QTDE_VOLUMES > 0)
		nTotVol += TRB->QTDE_VOLUMES
	endif
	dbSelectArea("TRB")
	dbSkip()
	
EndDo
nTotVol = StrZero(nTotVol,4)
nTotVol = Space(33)+"Total..."+nTotVol
Fwrite(n_outfile, nTotVol + chr(13)+chr(10), Len(cDetal2) + 2)

//---------------------------------//
//Fecha area aberta pelo TCQuery   //
//---------------------------------//
TRB->(dbCloseArea())

//----------------------------------------//
//Monta registro do Trailler do arquivo   //
//----------------------------------------//
//cTrailer := "T"+Space(312)+Space(9-Len(AllTrim(Str(nRegs))))+Alltrim(Str(nRegs))
//Fwrite(n_outfile, cTrailer + chr(10), Len(cTrailer) + 1)

//-----------------------------------//
//Fecha o arquivo texto em aberto    //
//-----------------------------------//
fClose(n_outfile)


Return(.t.)


//-----------------------------------------------------//
// Imprimir dados em dos NFE para transportadora       //
//-----------------------------------------------------//
****************************
Static Function OkImprimir()
****************************



//Ŀ
// Declaracao de Variaveis                                             
//

Local cDesc1        := ""
Local cDesc2        := ""
Local cDesc3        := ""
Local cPict         := ""
Local titulo        := ""
Local nLin          := 80
Local Cabec1        := ""
Local Cabec2        := ""
Local imprime       := .T.
Local aOrd 		    := {}
Private lEnd        := .F.
Private lAbortPrint := .F.
Private CbTxt       := ""
Private limite      := 80
Private tamanho     := "M"
Private nomeprog    := "RMEXPS4" // Coloque aqui o nome do programa para impressao no cabecalho
Private nTipo       := 18
Private aReturn     := { "Zebrado", 1, "Administracao", 2, 2, 1, "", 1}
Private nLastKey    := 0
Private cPerg       := Padr("RMEXPS4",30)
Private cbtxt       := Space(10)
Private cbcont      := 00
Private CONTFL      := 01
Private m_pag       := 01
Private wnrel       := "RMEXPS4" // Coloque aqui o nome do arquivo usado para impressao em disco
Private lContinua   := .T.

Private cString := "SF2"

//dbSelectArea("SF2")
//dbSetOrder(1)
//FilPior("35,50,55,20,25,45")

//validperg()
//pergunte(cPerg,.T.)

//Ŀ
// Monta a interface padrao com o usuario...                           
//

//wnrel := SetPrint(cString,NomeProg,cPerg,@titulo,cDesc1,cDesc2,cDesc3,.F.,aOrd,.T.,Tamanho,,.F.)
wnrel := SetPrint(cString,wnrel,cPerg,Titulo,cDesc1,cDesc2,cDesc3,.T.)

If nLastKey == 27
	Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
	Return
Endif

nTipo := If(aReturn[4]==1,15,18)

//Ŀ
// Processamento. RPTSTATUS monta janela com a regua de processamento. 
//

RptStatus({|| RunReport(Cabec1,Cabec2,Titulo,nLin) },Titulo)
Return

/*/


ͻ
Funo    RUNREPORT  Autor  AP6 IDE             Data   30/12/02   
͹
Descrio  Funcao auxiliar chamada pela RPTSTATUS. A funcao RPTSTATUS 
           monta a janela com a regua de processamento.               
͹
Uso        Programa principal                                         
ͼ


/*/

Static Function RunReport(Cabec1,Cabec2,Titulo,nLin)

Local nOrdem

//dbSelectArea(cString)
//dbSetOrder(1)

//Ŀ
// SETREGUA -> Indica quantos registros serao processados para a regua 
//

//SetRegua(RecCount())

//dbGoTop()

cQuery := "SELECT A1_RMPRIOE AS PRIORIDADE,A1_RMRTTRA AS ROTA, "
cQuery += "F2_DOC AS NUMERO_NF, F2_EMISSAO AS EMISSAO, "
cQuery += "F2_VOLUME1 AS QTDE_VOLUMES, A1_NOME AS DESTINATARIO, "
cQuery += "A1_MUN AS CIDADE, A1_DDD+A1_TEL AS FONE, "
cQuery += "F2_VALBRUT AS VALOR_TOTAL, F2_CHVNFE AS CHAVE_DE_ACESSO_NFE "
cQuery += "FROM SF2010 F INNER JOIN SA1010 A ON F2_CLIENTE = A1_COD AND F2_LOJA = A1_LOJA  "
cQuery += "INNER JOIN SD2010 D ON F2_DOC = D2_DOC AND F2_SERIE = D2_SERIE "
cQuery += "INNER JOIN SC5010 C ON D2_PEDIDO = C5_NUM "
cQuery += "WHERE  F.F2_SERIE <> 'ZZZ' AND A1_ATIVO = 'S' "
cQuery += "AND D.D2_FILIAL = '"+xFilial("SD2")+"' AND F.F2_FILIAL = '"+xFilial("SF2")+"' "
cQuery += "AND A.A1_FILIAL = '"+xFilial("SA1")+" ' AND C.C5_FILIAL = '"+xFilial("SC5")+"' AND "
cQuery += "C.D_E_L_E_T_ <> '*' AND F.D_E_L_E_T_ <> '*' AND D.D_E_L_E_T_ <> '*' AND "
cQuery += "A.D_E_L_E_T_ <> '*' AND C5_ROTARM = '100' AND "
cQuery += "F.F2_EMISSAO BETWEEN '"+DtoS(MV_PAR02)+"' AND '"+DtoS(MV_PAR03)+"' AND "
cQuery += "A.A1_RMPRIOE IN("+AllTrim(MV_PAR05)+") "
cQuery += "GROUP BY A1_RMPRIOE, A1_RMRTTRA, F2_DOC,"
cQuery += "F2_EMISSAO,F2_VOLUME1, A1_NOME,A1_MUN, A1_DDD,A1_TEL, "
cQuery += "F2_VALBRUT, F2_CHVNFE ORDER BY A1_RMPRIOE, NUMERO_NF "

//--------------------------------//
//Executa query e manda p/ TRB    //
//--------------------------------//
TCQUERY cQuery NEW ALIAS "TRB"

nTotalNf := 0
nVlTotal := 0
dbSelectArea("TRB")
dbGoTop()
While !Eof()
	
	
	If nLin > 55 // Salto de Pgina. Neste caso o formulario tem 55 linhas...
		nLin := 1
		@nLin,001 PSAY Chr(18)
		@nlin,000 PSAY "PENIEL DISTRIBUIDORA DE MEDICAMENTOS LTDA"
		nlin++
		@nlin,000 PSAY replicate("-",218)
		nlin++
		@nlin,120 PSAY " LISTAGEM DE NOTAS FISCAIS PARA AVERBACAO "
		nlin++
		@nlin,000 PSAY replicate("-",218)
		nlin++
		@nlin,000 PSAY "PRIORIDADE  ROTA  NUMERO NF  EMISSAO     QTDE. VOLUMES  DESTINATARIO                              CIDADE                                    FONE                VALOR TOTAL  CHAVE DE ACESSO NFE"
		nlin++
		@nlin,000 PSAY "==========  ====  =========  ==========  =============  ========================================  ========================================  ==================  ===========  ============================================"
		nlin++
	Endif
	
	#IFNDEF WINDOWS
		IF LastKey()==286
			@ 00,01 PSAY "** CANCELADO PELO OPERADOR **"
			lContinua := .F.
			Exit
		Endif
	#ELSE
		IF lAbortPrint
			@ 00,01 PSAY "** CANCELADO PELO OPERADOR **"
			lContinua := .F.
			Exit
		Endif
	#ENDIF
	
	
	If nLin > 55 // Salto de Pgina. Neste caso o formulario tem 55 linhas...
		nLin := 1
		@nLin,001 PSAY Chr(18)
		@nlin,000 PSAY "PENIEL DISTRIBUIDORA DE MEDICAMENTOS LTDA"
		nlin++
		@nlin,000 PSAY replicate("-",218)
		nlin++
		@nlin,120 PSAY" LISTAGEM DE NOTAS FISCAIS PARA AVERBACAO "
		nlin++
		@nlin,000 PSAY replicate("-",218)
		nlin++
		@nlin,000 PSAY "PRIORIDADE  ROTA  NUMERO NF  EMISSAO     QTDE. VOLUMES  DESTINATARIO                              CIDADE                                    FONE                VALOR TOTAL  CHAVE DE ACESSO NFE"
		nlin++
		@nlin,000 PSAY "==========  ====  =========  ==========  =============  ========================================  ========================================  ==================  ===========  ============================================"
		nlin++
	Endif
	
	
	nVlTotal += TRB->QTDE_VOLUMES
	if(TRB->QTDE_VOLUMES > 0)
		nTotalNf += TRB->VALOR_TOTAL
	endif
	@nlin,001 PSAY TRB->PRIORIDADE+Space(10) + TRB->ROTA+Space(3)+TRB->NUMERO_NF+Space(2) + DtoC(StoD(TRB->EMISSAO)) +Space(4) + StrZero(TRB->QTDE_VOLUMES,3)+Space(12)+ TRB->DESTINATARIO+Space(2)+TRB->CIDADE+Space(1) + SubStr(TRB->FONE,1,17)
	@nlin,157 PSAY TRB->VALOR_TOTAL Picture "@E 999,999,999.99"
	@nlin,172 PSAY Space(1) + TRB->CHAVE_DE_ACESSO_NFE
	nlin++
	
	dbselectarea("TRB")
	dbSkip() // Avanca o ponteiro do registro no arquivo
EndDo
@nlin,042 PSAY StrZero(nVlTotal,3)
@nlin,157 PSAY nTotalNf Picture "@E 999,999,999.99"

//---------------------------------//
//Fecha area aberta pelo TCQuery   //

//---------------------------------//
TRB->(dbCloseArea())


//Ŀ
// Finaliza a execucao do relatorio...                                 
//

SET DEVICE TO SCREEN

//Ŀ
// Se impressao em disco, chama o gerenciador de impressao...          
//

SetPgEject(.F.)
If aReturn[5]==1
	SET PRINTER TO
	dbCommitAll()
	OurSpool(wnrel)
Endif

MS_FLUSH()

Return



Return .t.



//----------------------------------//
// Grava o Arquivo com a xml da nfe //
//----------------------------------//
Static Function NfeXML(cCod, cSerie)

Local _aArea := GetArea()
Local cAlias := GetNextAlias()

Local cArquivo := AllTrim(MV_PAR04)+"xml\"+cSerie+cCod+".xml"
Local nFile := Fcreate(cArquivo,0)

BeginSQL Alias cAlias
	SELECT
	convert(varCHAR(8000),CONVERT(varbinary(8000),substring(XML_SIG,0,8000))) as XML,
	convert(varCHAR(8000),CONVERT(varbinary(8000),substring(XML_SIG,8000,8000))) as XML2,
	convert(varCHAR(8000),CONVERT(varbinary(8000),substring(XML_SIG,16000,8000))) as XML3,
	convert(varCHAR(8000),CONVERT(varbinary(8000),substring(XML_SIG,24000,8000))) as XML4,
	convert(varCHAR(8000),CONVERT(varbinary(8000),substring(XML_SIG,32000,8000))) as XML5	
	FROM SPED050
	WHERE NFE_ID = %exp:cSerie+cCod%
	
EndSQL

dbSelectArea(cAlias)
(cAlias)->(dbGoTop())
Fwrite(nFile, alltrim((cAlias)->XML) + alltrim((cAlias)->XML2) + alltrim((cAlias)->XML3) + alltrim((cAlias)->XML4) + alltrim((cAlias)->XML5), len(alltrim((cAlias)->XML) + alltrim((cAlias)->XML2) + alltrim((cAlias)->XML3) + alltrim((cAlias)->XML4) + alltrim((cAlias)->XML5)))
(cAlias)->(dbCloseArea())

fClose(nFile)